



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>php 解析url 和parse_url使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">php 解析url 和parse_url使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 23:43:18 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>通过url进行传值，是php中一个传值的重要手段。所以我们要经常对url里面所带的参数进行解析，如果我们知道了url传递参数名称，例如</p>
<p>/index.php?name=tank&amp;sex=1#top</p>
<p>我们就可以通过<strong>$_GET['name']，$_GET['sex']</strong>来获得传的数据。但是如果我们不知道这些变量名又怎么办呢？这也是写这篇博文的目的，因为自己老是忘，所以做个标记，下次就不要到处找了。</p>
<p>我们可以通php的变量来获得url和要传的参数字符串</p>
<p><strong>$_SERVER["QUERY_STRING"]</strong>&nbsp;name=tank&amp;sex=1</p>
<p><strong>$_SERVER["REQUEST_URI"]&nbsp;</strong>/index.php?name=tank&amp;sex=1</p>
<p>javascript也可以获得来源的url，<strong>document.referrer</strong>;方法有很多</p>
<p><strong>利用pathinfo</strong></p>
<div>
<pre class="prettyprint linenums">&lt;?php<br />
$test = pathinfo("http://localhost/index.php");<br />
print_r($test);<br />
?&gt;<br />
结果如下<br />
Array<br />
(<br />
    [dirname] =&gt; http://localhost //url的路径<br />
&nbsp; &nbsp; [basename] =&gt; index.php&nbsp; //完整文件名<br />
&nbsp;&nbsp;&nbsp; [extension] =&gt; php&nbsp; //文件名后缀<br />
&nbsp; &nbsp; [filename] =&gt; index //文件名<br />
)</pre>
</div>
<p>利用basename：</p>
<ol><li>&lt;?php</li>
<li>$test&nbsp;=&nbsp;basename("http://localhost/index.php?name=tank&amp;sex=1#top");</li>
<li>echo&nbsp;$test;</li>
<li>?&gt;</li>
<li>结果如下</li>
<li>index.php?name=tank&amp;sex=1#top</li></ol>
<p>php提供了一个强大的函数，<strong>parse_url，来专门解析url：</strong></p>
<div><a href="http://www.php.net/manual/en/language.pseudo-types.php#language.types.mixed" rel="external nofollow noreferrer">mixed</a>&nbsp;<strong>parse_url</strong>&nbsp;(&nbsp;string&nbsp;<code>$url</code>&nbsp;[,&nbsp;int&nbsp;<code>$component</code>&nbsp;= -1&nbsp;] ) 返回一个关联数组。</div>
<p>This function parses a URL and returns an associative array containing any of the various components of the URL that are present.</p>
<p>This function is&nbsp;<em>not</em>&nbsp;meant to validate the given URL, it only breaks it up into the above listed parts. Partial URLs are also accepted,&nbsp;<strong>parse_url()</strong>&nbsp;tries its best to parse them correctly.</p>
<p>部分url也可以接受。</p>
<p><em><code>component</code></em></p>
<p>Specify one of&nbsp;<strong><code>PHP_URL_SCHEME</code></strong>,&nbsp;<strong><code>PHP_URL_HOST</code></strong>,&nbsp;<strong><code>PHP_URL_PORT</code></strong>,&nbsp;<strong><code>PHP_URL_USER</code></strong>,&nbsp;<strong><code>PHP_URL_PASS</code></strong>,&nbsp;<strong><code>PHP_URL_PATH</code></strong>,&nbsp;<strong><code>PHP_URL_QUERY</code></strong>&nbsp;or<strong><code>PHP_URL_FRAGMENT</code></strong>&nbsp;to <strong>retrieve just a specific URL component as a&nbsp;<a href="http://www.php.net/manual/en/language.types.string.php" rel="external nofollow noreferrer">string</a>&nbsp;</strong>(except when&nbsp;<strong><code>PHP_URL_PORT</code></strong>&nbsp;is given, in which case the return value will be an&nbsp;<a href="http://www.php.net/manual/en/language.types.integer.php" rel="external nofollow noreferrer">integer</a>).</p>
<p>最常用的的选项是PHP_URL_PATH,返回路径。</p>
<div>
<pre class="prettyprint linenums">&lt;?php<br />
$url = 'http://username:password@hostname/path?arg=value#anchor';

print_r(parse_url($url));

echo parse_url($url, PHP_URL_PATH);<br />
?&gt;</pre>
</div>
<div>
<pre class="prettyprint linenums">Array<br />
(<br />
    [scheme] =&gt; http<br />
    [host] =&gt; hostname<br />
    [user] =&gt; username<br />
    [pass] =&gt; password<br />
    [path] =&gt; /path<br />
    [query] =&gt; arg=value<br />
    [fragment] =&gt; anchor<br />
)<br />
/path</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpxej9.html">基于shell脚本比较数字加减乘除</a>
		</li>
						<li><a href="https://www.batexi.com/a/49535068.html">java高新技术-基本数据类型拆装箱及享元设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlx2wkq.html">easyUI的dateBox控制时间格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zx6kxq.html">【matlab】设定C&plus;&plus;编译器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1gk2n9.html">Android DatePickerDialog TimepickerDialog</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ygl25q.html">Java过滤器原理方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11r6x9.html">mysql 循环控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj0wlq.html">显示ios设备信息的程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yjy53q.html">SQL常见的可优化点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok46w59.html">Linq之查询表达式语法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn4rgq.html">php session偶尔写入失败的原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vp0538.html">KDE&sol;QT与GNOME&sol;GTK比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0dgmwq.html">java jvm学习笔记五（实践自己写的类装载器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o417y9.html">中国&period;net域名网站的&OpenCurlyDoubleQuote;前世今生&rdquo;，那些年的光辉</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pvl38.html">unity的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4d669.html">ASP&period;net core 2&period;0&period;0 中 asp&period;net identity 2&period;0&period;0 的基本使用（二）&mdash;启用用户管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojo7olq.html">CodeChef  Little Elephant and Mouses &lbrack;DP&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjxmkj8.html">你不知道的JavaScript--Item26  异步的脚本加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpy1d0q.html">Abp通用配置模块的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y4m4z8.html">Asp&period;Net Core 轻松学-一行代码搞定文件上传</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0yky4q.html">Delphi 预编译指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1rr6g8.html">perl 第十四章 Perl5的包和模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m777j8.html">HDU 1849 Rabbit and Grass</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp00w39.html">【水一发next&lowbar;permutation】poj 1146&mdash;&mdash;ID Codesm</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1wdwdq.html">取代奶瓶Minidwep-gtk 破 WPA 全攻略</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgzdld8.html">D3DXMatrixMultiply 函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyeywk9.html">HYSBZ1588 营业额统计【Splay】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zgp5n9.html">Setting property &amp;&num;39&semi;source&amp;&num;39&semi; to &amp;&num;39&semi;org&period;eclipse&period;jst&period;jee&period;server &lbrack;问题点数：40分&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdnmmy9.html">linux ln 命令（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkwl5j8.html">STL中copy算法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
